<!-- Build script for marcupload form -->

<project name="marcupload" default="compile" basedir=".">

<property file="build.properties"/>

<property name="common.home"    value="common"/>
<property name="src" 		value="${basedir}/src"/>
<property name="build" 		value="${basedir}/tmp"/>
<property name="dist" 		value="${basedir}/dist"/>
<property name="api" 		value="${basedir}/doc/api"/>
<property name="lib" 		value="${basedir}/lib"/>
<property name="filtered"	value="${build}/filtered"/>
<property name="test"       value="${basedir}/doc/test"/>

<property name="appName" 	       value="marcupload"/>
<property name="compile.debug"       value="true"/>
<property name="compile.deprecation" value="true"/>

<path id="classpath">
	<!--Put needed packages in the classpath-->
  <fileset id="lib" dir="${lib}" includes="*" />
	<pathelement location="${build}/classes"/>
</path>

<!-- common config -->
<import file="${common.home}/remote.xml"/>
<import file="${common.home}/version.xml"/>

<!--======================================================================-->
<!-- PREPARE -->
<!--======================================================================-->
<target name="prepare" description="Create needed folders">
	<!-- Create the build directory structure -->
	<mkdir dir="${build}/classes"/>
	<mkdir dir="${api}"/>
	<mkdir dir="${dist}"/>
	<mkdir dir="${filtered}"/>
	<mkdir dir="${test}"/>	
	<mkdir dir="${lib}"/>	
</target>

<!--======================================================================-->
<!-- COMPILE -->
<!--======================================================================-->
<target name="compile" depends="clean, prepare, version"
    description="Compile sources">

    <!--***************************************************************-->
    <!-- Perform filter operations -->
    <!--***************************************************************-->
        <copy todir="${filtered}" overwrite="true">
            <fileset dir="${src}">
                <include name="**/*"/>
            </fileset>
        
            <filterset refid="version-filters"/>
        </copy>
    <!--***************************************************************-->
    <javac debug="${compile.debug}" deprecation="${compile.deprecation}" 
        destdir="${build}/classes" srcdir="${filtered}/java" target="1.5">
        <classpath refid="classpath"/>
    </javac>

</target>

  <!--======================================================================-->
  <!-- VERSION -->
  <!--======================================================================-->
  <target name="version" description="Create version properties">
    <exec executable="git" outputproperty="git.version"
        failifexecutionfails="true" errorproperty="">
      <arg value="describe"/>
      <arg value="--all"/>
      <arg value="--always"/>
      <arg value="--long"/>
      <arg value="--abbrev=40"/>
      <arg value="HEAD"/>
    </exec>
    <tstamp>
      <format property="build_date" pattern="yyyy-MM-dd"/>
      <format property="build_time" pattern="HH:mm:ss"/>
    </tstamp>

    <!-- filters -->
    <filterset id="version-filters">
      <filter token="version_string" value="${git.version}"/>
      <filter token="build_date"     value="${build_date}"/>
      <filter token="build_time"     value="${build_time}"/>
      <filter token="user_name"      value="${user.name}"/>
    </filterset>
    <echo level="info" message="version: ${git.version}"/>
    <echo level="info" message="built..: ${build_date} ${build_time} by ${user_name}"/>
  </target>

<!--======================================================================-->
<!-- JAVADOC -->
<!--======================================================================-->
<target name="javadoc" depends="clean" description="Create JavaDocs">
	<javadoc destdir="${api}" packagenames="edu.ucsd.library.${appName}.*"
         author="true">
		<sourcepath>
			<pathelement location="${src}/java"/>
		</sourcepath>
	</javadoc>
</target>

<!--======================================================================-->
<!-- CLEAN -->
<!--======================================================================-->
<target name="clean" description="Delete build, dist, and api directory">
    <delete dir="${build}"/>
    <delete dir="${dist}"/>
    <delete dir="${api}"/>
    <delete dir="${filtered}"/>
    <delete dir="${test}"/>
</target>

<!--======================================================================-->
<!-- DEPLOY -->
<!--======================================================================-->
<target name="deploy" depends="webapp"
    description="Deploy application to servlet container">

    <!-- Remove existing instances -->
    <delete file="${deploy.home}/${appName}.war"/>
    <delete dir="${deploy.home}/${appName}" />
    
    <!-- Deploying to webapps directory -->
    <unwar src="${dist}/${appName}.war" dest="${deploy.home}/${appName}" />
    
  	<mkdir dir="${deploy.home}/${appName}/raw"/>
    
    <!-- Copy the JARS to the Tomcat shared library -->
    <copy todir="${catalina.sharedlib}" >
    	<fileset dir="${jars.home}" >
    		<include name="**/*.jar"/>
    	</fileset>
    </copy>
    
</target>
<!--======================================================================-->
<!-- DEPLOY CLEAN-->
<!--======================================================================-->
<target name="deployclean" depends="deploy" description="deploys, then cleans...">
    <delete dir="${build}"/>
    <delete dir="${dist}"/>
    <delete dir="${api}"/>
    <delete dir="${filtered}"/>
    <delete dir="${test}"/>
</target>
<!--======================================================================-->
<!-- WEBAPP -->
<!--======================================================================-->
<target name="webapp" depends="compile" description="Creates a Web Archive">

    <war warfile="${dist}/${appName}.war" webxml="${filtered}/webinf/web.xml">
<!--
        <fileset dir="${filtered}">
            <include name="html/**/*.*"/>
            <include name="jsp/**/*.*"/>
        </fileset>
-->
        <fileset dir="${filtered}/html"/>

        <fileset dir="${filtered}/jsp"/>
        <lib dir="${lib}" />
        <classes dir="${build}/classes" />
        <webinf dir="${filtered}/webinf" excludes="web.xml" />
        <metainf dir="${filtered}/metainf"/>
    </war>
</target>

</project>
